local addonInfo, privateVars = ...

if nkAM_Search ~= nil then return end

nkAM_Search = {}

privateVars.modules = {}

function nkAM_Search.main(addon)

	if (addon == addonInfo.toc.Identifier) then
		if nkAAPI.checkVersion (addonInfo.toc.Identifier, "nkAdvisor", "4.1.0") == false then return end
		nkAAPI.addModule(addonInfo.toc.Identifier, addonInfo.toc.Version, 2, privateVars.langTexts.ui.tabSearch, nkAM_Search.buildPanel)
		EnKai.version.init(addonInfo.toc.Identifier, addonInfo.toc.Version)
	end
	
end

function nkAM_Search.settings() 
	
	local settings = {}
	
	if nkAM_Search_Setup == nil then
		nkAM_Search_Setup = settings
	else
		for k, v in pairs (settings) do if nkAM_Search_Setup[k] == nil then nkAM_Search_Setup[k] = v end end
	end	
	
end

table.insert(Event.Addon.Load.End, {nkAM_Search.main, "nkAdvisor_Search", "addonLoaded"})
table.insert(Event.Addon.SavedVariables.Load.End, {nkAM_Search.settings, "nkAdvisor_Search", "vaiablesLoaded"})


function nkAM_Search.gridUpdate(frame, grid)

	local pane = nkAAPI.getPane('nkAdvisor_Search')

	if pane.slotSelect == nil then return end
	
	local itemType = pane.slotSelect:GetSelectedValue()
	
	local itemCat = nil
	local items = nil
	local filter = frame.filterSelect:GetSelectedValue()
	local ratingDisplay = frame.ratingCheckbox:GetChecked()
	local exclDPS = frame.exclDPSCheckbox:GetChecked()
	local equipedRating = 0
	
	if itemType == nil or itemType == '' then return end
	
	if string.find (itemType, ';') ~= nil then
		local itemTypeArray = EnKai.strings.split(itemType, ';')		
		local itemArray = {}
				
		for k, v in pairs (itemTypeArray) do
			local subType = nil
			local itemType = v
			if string.find(itemType, ':') ~= nil then 
				subType = string.sub(itemType, string.find(itemType, ':')+1)
				itemType = string.sub(itemType, 1, string.find(itemType, ':')-1)
			end
			
			local thisitems = nkItemBase.Query.allByType (itemType, subType, nkAAPI.getCalling(), true, true)
			if thisitems ~= nil then EnKai.tools.table.mergeIndexed (itemArray, thisitems) end
			
			local thiscrafted = nkItemBase.Query.allCraftingByType(itemType, subType, nkAAPI.getCalling(), true)
			
			if thiscrafted ~= nil then EnKai.tools.table.mergeIndexed (itemArray, thiscrafted) end
      if itemCat == nil then itemCat = nkItemBase.getItemCategory (itemType) end
		end
		
		items = itemArray
	else
		local subType = nil
		if string.find(itemType, ':') ~= nil then 
			subType = string.sub(itemType, string.find(itemType, ':')+1)
			itemType = string.sub(itemType, 1, string.find(itemType, ':')-1)
		end
		
		items = nkItemBase.Query.allByType(itemType, subType, nkAAPI.getCalling(), true, true)
		
		local thiscrafted = nkItemBase.Query.allCraftingByType(itemType, subType, nkAAPI.getCalling(), true)
		if thiscrafted ~= nil then EnKai.tools.table.mergeIndexed (items, thiscrafted) end
		
		itemCat = nkItemBase.getItemCategory (itemType)
	end
	
	if itemCat == 'other' or itemCat == 'single' then 
		itemCat = 'acc' 
	elseif itemCat == 'shield' then
		itemCat = 'armor'
	end
	
	local cols = nil
	
	if nkAAPI.isModuleRegistered ('nkAdvisor_Rating') == true then	
		cols = { { align = 'left', header = privateVars.langTexts.grid.headerName, width = 285 }, {header = privateVars.langTexts.grid.headerRating, align = "center",  width = 65} }
	else
		cols = { { align = 'left', header = privateVars.langTexts.grid.headerName, width = 350 } }
	end
  
  local content = nkAM_Search.ressources.contents[nkAAPI.getCalling()][itemCat]
	
	--for k, v in pairs ( nkAM_Search.ressources.headers[nkAAPI.getCalling()][itemCat] ) do table.insert (cols, v) end
	for k, v in pairs ( content ) do 
	  if v.sub('resi', 1, string.len(v)) == 1 then	
			table.insert (cols, { align = "center", width = 30, header = nkAM_Search.ressources.headers[v] })
		elseif v.sub('armor', 1, string.len(v)) == 1 then
			table.insert (cols, { align = "center", width = 45, header = nkAM_Search.ressources.headers[v] })
		else
			table.insert (cols, { align = "center", width = 40, header = nkAM_Search.ressources.headers[v] })
		end 
	end
	
	--pane.grid:update(cols, 18, {counter = 1, headerHeight = 25} )
	grid:UpdateLayout(cols)
	
	local values = {}

	for k, v in pairs(items) do
		
		local thisValue = {}

		table.insert (thisValue, {key = k, value = v[string.lower(EnKai.tools.lang.getLanguageShort())], color = nkItemBase.qualityColor[tonumber(v['q'])]})
		
		if nkAAPI.isModuleRegistered ('nkAdvisor_Rating') == true then
			if (filter ~= 'all' or ratingDisplay == true) and equipedRating == 0 then 
				local tempData = nkItemBase.getByKey(k)
				equipedRating = nkAAPI.callModuleFunc ('nkAdvisor_Rating', 'getEquipedRating', { itemData = tempData, exclDPS = exclDPS })
			end
		
			local riftCalc = nkAAPI.callModuleFunc ('nkAdvisor_Rating', 'calcItem', { item = v, exclDPS = exclDPS })
			if ratingDisplay == true then
				if riftCalc - equipedRating >= 0 then
					table.insert (thisValue, {value = string.format('%3.1f', riftCalc - equipedRating), color = { 0, 1, 0, 1}} )
				else
					table.insert (thisValue, {value = string.format('%3.1f', riftCalc - equipedRating), color = { 1, 0, 0, 1 }} )
				end
			else
				table.insert (thisValue, {value = string.format('%3.1f', riftCalc)} )
			end
		end

		for idx = 1, #content, 1 do
			if v[content[idx]] == nil then
				table.insert (thisValue, 0)
			else
				table.insert (thisValue, tonumber(v[content[idx]]))
			end
		end
		
		table.insert (values, thisValue)
	end

	if nkAAPI.isModuleRegistered ('nkAdvisor_Rating') == true then
		table.sort (values, function (v1, v2) return tonumber(v1[2].value) > tonumber(v2[2].value) end )
	else
		table.sort (values, function (v1, v2) return v1[1].value < v2[1].value end )
	end

	local maxCount = 0
	
	if nkAAPI.isModuleRegistered ('nkAdvisor_Rating') == true and filter ~= 'all' and equipedRating > 0 then
		local maxDiff = tonumber(filter)
		local filteredValues = {}
		local downgradPos = 0
		
		-- find first downgrade
		
		for k, v in pairs (values) do
			local value = tonumber(v[2].value)
			if ratingDisplay == true then value = value + equipedRating end
		
			if value <= equipedRating then
				downgradPos = k
				break
			end
		end

		for idx = (downgradPos-maxDiff), downgradPos, 1 do
			if values[idx] ~= nil then table.insert (filteredValues, values[idx]) end
		end
				
		grid:SetRowPos(1, false)
		grid:SetCellValues(filteredValues)
		
		maxCount = #filteredValues
	else
		grid:SetRowPos(1, false)
		grid:SetCellValues(values)
		
		maxCount = #values
	end
		
	if (maxCount-18) > 0 then
		frame.slider:SetRange (1, maxCount-18)
  else
    frame.slider:SetRange (1,1)
  end
		--frame.slider:SetVisible(true)
	--else
		--frame.slider:SetVisible(false)
	--end

end

function nkAM_Search.search (frame, grid, reset)

	frame.editSearch:Leave()
	
	local searchValue = frame.editSearch:GetText()
	grid:filter (searchValue, 1, reset)
	
	local gridValues = grid:GetCellValues()
	
	if gridValues ~= nil and (#gridValues-18) > 0 then
		frame.slider:SetRange (1, #gridValues-17)
		frame.slider:SetVisible(true)
	else
		frame.slider:SetVisible(false)
	end
	
end
