local addonInfo, privateVars = ...

function nkAM_Search.buildPanel(frame, uiObject)

	nkAAPI.registerCloseFunc ('nkAdvisor_Search', nkAM_Search.closePanel, { frame = frame })
	
	local grid
	
	local selection = nkAM_Search.ressources.selection[nkAAPI.getCalling()]
    
  frame.slotSelect = EnKai.uiCreateFrame("nkCombobox", frame:GetName() .. '.slotSelect', frame)
  frame.slotSelect:SetPoint("TOPLEFT", frame, "TOPLEFT")
  frame.slotSelect:SetWidth(200)
  frame.slotSelect:SetLabelWidth(0)
  frame.slotSelect:SetSelection(selection)
  frame.slotSelect:SetSelectedValue("")
  frame.slotSelect:SetLayer(4)
  
  Command.Event.Attach(EnKai.events[frame:GetName() .. '.slotSelect'].ComboChanged, function (_, newValue)
    nkAM_Search.gridUpdate(frame, grid)
  end, frame:GetName() .. '.slotSelect.ComboChanged')
  
  -- SEARCH FIELD
  
  frame.editSearchLabel = UI.CreateFrame ('Text', frame:GetName() .. '.editSearchLabel', frame)
  frame.editSearchLabel:SetText(privateVars.langTexts.ui.lblSearch)
  frame.editSearchLabel:SetPoint("CENTERLEFT", frame.slotSelect, "CENTERRIGHT", 20, 0)
  frame.editSearchLabel:SetWidth(70)
  frame.editSearchLabel:SetFontSize(13)
  frame.editSearchLabel:SetLayer(2)
  
  frame.editSearch = EnKai.uiCreateFrame("nkTextfield", frame:GetName() .. '.editSearch', frame)  
  frame.editSearch:SetPoint("CENTERLEFT", frame.editSearchLabel, "CENTERRIGHT")
  frame.editSearch:SetWidth(150)
  frame.editSearch:SetHeight(22)
  frame.editSearch:SetText( "" )
  frame.editSearch:SetLayer(2)
  
  Command.Event.Attach(EnKai.events[frame:GetName() .. '.editSearch'].TextfieldChanged, function (_, newValue)    
    nkAM_Search.search(frame, grid, false)
  end, frame:GetName() .. '.editSearch.TextfieldChanged')
  
  frame.resetSearch = UI.CreateFrame('Texture', frame:GetName() .. '.resetSearch', frame )
  frame.resetSearch:SetTextureAsync("nkAdvisor_Search", "gfx/iconCancel.png")
  frame.resetSearch:SetPoint("CENTERLEFT", frame.editSearch, "CENTERRIGHT", 5, 0)
  frame.resetSearch:SetWidth(16)
  frame.resetSearch:SetHeight(16)
  frame.resetSearch:SetLayer(2)
  
  frame.resetSearch:EventAttach(Event.UI.Input.Mouse.Left.Click, function ()
    nkAM_Search.search(frame, grid, true)
  end, frame:GetName() .. ".resetSearch.Left.Click")
  
  -- FILTER SELECTION

  local filter = {{label = privateVars.langTexts.ui.selFilterAll, value = 'all'}, {label = privateVars.langTexts.ui.selFilter10, value = '10'}, {label = privateVars.langTexts.ui.selFilter20, value = '20'}, {label = privateVars.langTexts.ui.selFilter50, value = '50'}}
    
  frame.filterSelect = EnKai.uiCreateFrame("nkCombobox", frame:GetName() .. '.filterSelect', frame)
  frame.filterSelect:SetPoint("CENTERLEFT", frame.resetSearch, "CENTERRIGHT", 30, 0)
  frame.filterSelect:SetWidth(200)
  frame.filterSelect:SetLabelWidth(0)
  frame.filterSelect:SetSelection(filter)
  frame.filterSelect:SetSelectedValue("all")
  frame.filterSelect:SetLayer(4)
  
  Command.Event.Attach(EnKai.events[frame:GetName() .. '.filterSelect'].ComboChanged, function (_, newValue)
    frame.slider:SetVisible(false)
    nkAM_Search.gridUpdate(frame, grid)
  end, frame:GetName() .. '.filterSelect.ComboChanged')

  frame.ratingCheckbox = EnKai.uiCreateFrame("nkCheckbox", frame:GetName() .. '.ratingCheckbox', frame)
  frame.ratingCheckbox:SetText(privateVars.langTexts.ui.cbRatingDisplay)
  frame.ratingCheckbox:SetChecked(false)
  frame.ratingCheckbox:SetPoint("CENTERLEFT", frame.filterSelect, "CENTERRIGHT", 20, 0)
  frame.ratingCheckbox:SetLayer(2)
  
  Command.Event.Attach(EnKai.events[frame:GetName() .. '.ratingCheckbox'].CheckboxChanged, function (_, newValue)
    nkAM_Search.gridUpdate(frame, grid)
  end, frame:GetName() .. '.ratingCheckbox.CheckboxChanged')
  
  frame.exclDPSCheckbox = EnKai.uiCreateFrame("nkCheckbox", frame:GetName() .. '.exclDPSCheckbox', frame)
  frame.exclDPSCheckbox:SetText(privateVars.langTexts.ui.cbExclDPS)
  frame.exclDPSCheckbox:SetChecked(false)
  frame.exclDPSCheckbox:SetWidth(135)
  frame.exclDPSCheckbox:SetPoint("CENTERLEFT", frame.ratingCheckbox, "CENTERRIGHT", 20, 0)
  frame.exclDPSCheckbox:SetLayer(2)
  
  Command.Event.Attach(EnKai.events[frame:GetName() .. '.exclDPSCheckbox'].CheckboxChanged, function (_, newValue)
    nkAM_Search.gridUpdate(frame, grid)
  end, frame:GetName() .. '.exclDPSCheckbox.CheckboxChanged')

	grid = EnKai.uiCreateFrame("nkGrid", frame:GetName() .. '.grid', frame)
			
	grid:SetPoint("TOPLEFT", frame.slotSelect, "BOTTOMLEFT", 0, 10)
	grid:SetTransparentHeader()
	grid:SetSelectable(true)
	grid:SetLayer(3)
	grid:SetHeaderHeight(25)
	grid:SetHeaderFontSize(11)
	grid:SetFontSize(13)
	grid:SetSortable(true)
	
	local gridRows = 19
	
	local cols = nil
	
	if nkAAPI.isModuleRegistered ('nkAdvisor_Rating') == true then	
		cols = { { align = 'left', header = privateVars.langTexts.grid.headerName, width = 285 }, {header = privateVars.langTexts.grid.headerRating, align = "center", width = 65} }
	else
		cols = { { align = 'left', header = privateVars.langTexts.grid.headerName, width = 350 } }
	end
	
	local content = nkAM_Search.ressources.contents[nkAAPI.getCalling()]['essence']
	
	--for k, v in pairs ( nkAM_Search.ressources.headers[nkAAPI.getCalling()][itemCat] ) do table.insert (cols, v) end
	for k, v in pairs ( content ) do 
		if v.sub('resi', 1, string.len(v)) == 1 then	
			table.insert (cols, { align = "center", width = 30, header = nkAM_Search.ressources.headers[v] })
		elseif v.sub('armor', 1, string.len(v)) == 1 then
			table.insert (cols, { align = "center", width = 45, header = nkAM_Search.ressources.headers[v] })
		else
			table.insert (cols, { align = "center", width = 40, header = nkAM_Search.ressources.headers[v] })
		end 
	end
	
--	for k, v in pairs ( nkAM_Search.ressources.headers[nkAAPI.getCalling()]['essence'] ) do
--		table.insert (cols, v)
--	end
	
	grid:SetVisible(false)	
	grid:Layout (cols, gridRows)	
	
	local function checkSlot (key, subType)
	  if string.find(subType, ':') ~= nil then subType = string.sub(subType, 1, string.find(subType, ':')-1) end
    
    local itemData = nkItemBase.Query.byKey (key, false, subType, false)
    if itemData == nil then return false end
    
    local mouse = Inspect.Mouse()
    local xpos, ypos = mouse.x - grid:GetLeft() + 20, mouse.y - grid:GetTop()
    
    nkAAPI.createTooltip(itemData.akey, itemData, grid, xpos, ypos, true)
    return true 
  end
								
	Command.Event.Attach(EnKai.events[frame:GetName() .. '.grid'].GridFinished, function ()
		nkAM_Search.gridUpdate(frame, grid)
		grid:SetVisible(true)
	end, frame:GetName() .. '.grid.GridFinished')
	
	Command.Event.Attach(EnKai.events[frame:GetName() .. '.grid'].LayoutUpdated, function ()
	  local cell = grid:GetBorderCell("topright", false)
	  if cell ~= nil then 
	    frame.slider:SetPoint("TOPLEFT", cell, "TOPRIGHT")
	    if frame.slider:GetRange()[2] ~= 1 then
	      frame.slider:SetVisible(true)
	    end
	  end	  
	end, frame:GetName() .. '.grid.LayoutUpdated')
	
	Command.Event.Attach(EnKai.events[frame:GetName() .. '.grid'].WheelForward, function (_, rowPos)
		frame.slider:AdjustValue (rowPos)
	end, frame:GetName() .. '.grid.Grid.WheelForward')
	
	Command.Event.Attach(EnKai.events[frame:GetName() .. '.grid'].WheelBack, function (_, rowPos)
		frame.slider:AdjustValue (rowPos)
	end, frame:GetName() .. '.grid.Grid.WheelBack')
	 
	Command.Event.Attach(EnKai.events[frame:GetName() .. '.grid'].MouseOver, function (_, rowPos)
	 	local parent = grid:GetCell(rowPos, 1)
	 	local key = grid:GetKey(grid:GetRowPos() + rowPos -1)
	 	if key == nil then return end
	 	
	 	local subType = frame.slotSelect:GetSelectedValue()
	 	
	 	if string.find(subType, ';') ~= nil then 
      local tmpSubType = EnKai.strings.split(subType, ';')
      
      for idx = 1, #tmpSubType, 1 do
        if checkSlot (key, tmpSubType[idx]) == true then return end
      end
    else
      checkSlot (key, subType)   
	 	end
	 	    
	end, frame:GetName() .. '.grid.Grid.MouseOver')
	 
	Command.Event.Attach(EnKai.events[frame:GetName() .. '.grid'].MouseOut, function (_, rowPos)
		nkAAPI.hideTooltip()
	end, frame:GetName() .. '.grid.Grid.MouseOut')
	 
	frame.slider = EnKai.uiCreateFrame("nkScrollbox", frame:GetName() .. ".slider", grid)	
		
	frame.slider:SetPoint("TOPLEFT", grid, "TOPRIGHT", 0, 25 )
	frame.slider:SetHeight(grid:GetHeight() - 25)
	frame.slider:SetRange(1, 1)
	frame.slider:SetVisible(false)
	frame.slider:SetLayer(2)
	
	Command.Event.Attach(EnKai.events[frame:GetName() .. ".slider"].ScrollboxChanged, function ()		
		grid:SetRowPos(math.floor(frame.slider:GetValue('value')), true)
	end, frame:GetName() .. 'slider.ScrollboxChanged')
		
	if nkAAPI.isModuleRegistered ('nkAdvisor_Rating') == false then	
		frame.filterSelect:SetVisible(false)
		frame.ratingCheckbox:SetVisible(false)
		frame.exclDPSCheckbox:SetVisible(false)
	end

	frame.dataData = EnKai.uiCreateFrame("nkText", frame:GetName() .. ".updateDate", frame)
	frame.dataData:SetText(string.format(privateVars.langTexts.ui.updateDate, nkItemBase.updateDate))
	frame.dataData:SetFontSize(13)
	frame.dataData:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT")
	frame.dataData:SetLayer(2)
	
end

function nkAM_Search.closePanel(paraTable)

	local frame = paraTable.frame

	if frame.editSearch ~= nil then frame.editSearch:Leave() end	

end